require "moto_recall/version"
require "moto_recall/class_map"
require "moto_recall/recall"
require "moto_recall/recall_set"
require "moto_recall/client/generic_client"
require "moto_recall/client/acura"
require "moto_recall/client/audi"
require "moto_recall/client/bmw"
require "moto_recall/client/chrysler"
require "moto_recall/client/ford"
require "moto_recall/client/general_motors"
require "moto_recall/client/honda"
require "moto_recall/client/hyundai"
require "moto_recall/client/infiniti"
require "moto_recall/client/isuzu"
require "moto_recall/client/jaguar"
require "moto_recall/client/kia"
require "moto_recall/client/mazda"
require "moto_recall/client/mitsubishi"
require "moto_recall/client/nissan"
require "moto_recall/client/subaru"
require "moto_recall/client/volkswagen"
require "moto_recall/client/volvo"

module MotoRecall
  class ClientException < StandardError; end
  class InvalidVinError < StandardError; end

  def self.find(make, vin)
    raise InvalidVinError, "VIN is not 17 chars" if vin.length != 17
    client_class = ClassMap.class_for_make(make)
    begin
      client_class.new.find(vin)
    rescue StandardError => error
      raise MotoRecall::ClientException, "(#{client_class}) #{error.class}: #{error.inspect}\n#{error.backtrace.join("\n")}"
    end
  end
end
