require "yaml"

module MotoRecall
  class UnsupportedMakeError < StandardError; end
  module ClassMap
    CLASS_MAP_PATH = "data/class_map.yml"

    def self.class_for_make(make)
      make_class_name = data[make.to_s.downcase] || make.capitalize
      begin
        Object.const_get("MotoRecall::Client::#{make_class_name}")
      rescue NameError
        raise UnsupportedMakeError, "Invalid Make: #{make}"
      end
    end

    def self.data
      path = File.join(File.dirname(__FILE__), "..", "..", CLASS_MAP_PATH)
      @data || begin
        YAML.load_file(path)
      end
    end
  end
end
