require "json"

module MotoRecall::Client
  class Bmw < GenericClient
    def self.url(vin)
      "http://www.bmwusa.com/Services/VinRecallService.svc/GetRecallCampaignsForVin/#{vin}"
    end

    def process(response)
      parsed_data = JSON.parse(response)
      parsed_data["ViewModel"]["RecallCampaigns"] rescue []
    end

    def format(recall)
      {
        type: nil,
        nhtsa_number: recall["RecallNumber"],
        oem_number: recall["ManufacturerRecallNumber"],
        date: recall["RecallDate"],
        title: recall["Title"],
        description: recall["Description"],
        safety_risk: recall["SafetyRiskDescription"],
        remedy: recall["RemedyDescription"],
        status: recall["ManufacturerRecallStatus"],
        notes: recall["ManufacturerNotes"]
      }
    end
  end
end
