require "mechanize"
require "json"

module MotoRecall::Client
  class GeneralMotors < GenericClient
    def self.url(vin)
      "https://my.gm.com/services/#{vin}/recalls"
    end

    def fetch(vin)
      agent = Mechanize.new
      response = agent.get(url(vin))
      response.body
    end

    def process(response)
      parsed_response = JSON.parse(response)
      if parsed_response["data"] && parsed_response["data"]["recalls"]
        parsed_response["data"]["recalls"]
      else
        []
      end
    end

    def format(recall)
      {
        type: recall["recall_type"],
        nhtsa_number: recall["nhtsa_recall_number"],
        oem_number: recall["mfr_recall_number"],
        date: recall["recall_date"],
        title: recall["recall_title"],
        description: recall["recall_description"],
        safety_risk: recall["safety_risk_description"],
        remedy: recall["remedy_description"],
        status: recall["mfr_recall_status"],
        notes: nil
      }
    end
  end
end
