require "openssl"

# don't verify peer ssl certs, not worried about security here
# http://stackoverflow.com/questions/33669611/opensslsslsslerror-ssl-connect-returned-1-errno-0-state-error-certificate
OpenSSL::SSL::VERIFY_PEER = OpenSSL::SSL::VERIFY_NONE
I_KNOW_THAT_OPENSSL_VERIFY_PEER_EQUALS_VERIFY_NONE_IS_WRONG = nil

module MotoRecall::Client
  class GenericClient

    def initialize
    end

    def url(vin = nil)
      self.class.url(vin)
    end

    def self.url(vin = nil)
      raise NotImplementedError
    end

    def find(vin)
      response = fetch(vin)
      raw_recalls = process(response) || []
      recalls = raw_recalls.map { |recall| MotoRecall::Recall.new(format(recall)) }
      MotoRecall::RecallSet.new(recalls, {
        original_response: response
      })
    end

    def fetch(vin)
      url_with_vin = url(vin)
      Net::HTTP.get(URI(url_with_vin))
    end

    def format(recall)
      raise NotImplementedError
    end

    def process(response)
      raise NotImplementedError
    end
  end
end
