require "json"

# If you make any changes to this file, make sure to also make them in the
# Acura client as they are pretty much the same running on different domains

module MotoRecall::Client
  class Honda < GenericClient
    def self.url(vin)
      "http://owners.honda.com/Recalls/GetRecallsByVin/#{vin}/true"
    end

    def process(response)
      parsed_response = JSON.parse(response)
      parsed_response["CampaignTypes"][0]["Campaigns"] rescue []
    end

    def format(recall)
      {
        type: recall["AgencyType"],
        nhtsa_number: recall["RecallNumber"],
        oem_number: recall["Id"],
        date: recall["RecallDate"],
        title: recall["Description"],
        description: recall["RecallDescription"],
        safety_risk: recall["SafetyRiskDescription"],
        remedy: recall["RemedyDescription"],
        status: recall["RecallStatus"],
        notes: nil
      }
    end
  end
end
