require "mechanize"
require "json"

module MotoRecall::Client
  class Hyundai < GenericClient
    def self.url(vin = nil)
      "https://autoservice.hyundaiusa.com/CampaignHome/?VIN=#{vin}"
    end

    def fetch(vin)
      agent = Mechanize.new

      data = { txtVIN: vin }

      response = agent.post(url(vin), data)

      response.body
    end

    def process(response)
      doc = Nokogiri::HTML(response)
      table = doc.css("#open-campaign-table")
      table.css("tr.campaign-individual").map do |tr|
        tr.css("td").reduce({}) do |memo, td|
          memo[td.attr("data-label")] = td.text.sub(/\s+:/, "").strip
          memo
        end
      end
    end

    def format(recall)
      {
        type: recall["Campaign Type"],
        nhtsa_number: nil,
        oem_number: recall["Campaign#"],
        date: recall["Campaign Date"],
        title: nil,
        description: recall["Campaign Description"],
        safety_risk: nil,
        remedy: recall["Customer Action"],
        status: nil,
        notes: nil
      }
    end
  end
end
