require "json"

module MotoRecall::Client
  class Infiniti < GenericClient
    def self.url(vin)
      "http://www.infinitiusa.com/dealercenter/api/recalls?vin=#{vin}"
    end

    def process(data)
      parsed_data = JSON.parse(data)
      parsed_data["recalls"]
    end

    def format(recall)
      {
        type: recall["typeCode"],
        nhtsa_number: recall["nhtsaId"],
        oem_number: recall["nnaId"],
        date: recall["effectiveDate"],
        title: nil,
        description: "#{recall["primaryDescription"]} #{recall["secondaryDescription"]}",
        safety_risk: recall["riskIfNotRepaired"],
        remedy: recall["remedyDescription"],
        status: nil,
        notes: nil
      }
    end
  end
end
