module MotoRecall::Client
  class Isuzu < GenericClient
    def self.url(vin = nil)
      "http://www.isuzu.com/index.jsp"
    end

    def fetch(vin)
      agent = Mechanize.new
      agent.user_agent_alias = "Windows Chrome"

      response = agent.post(url, {
        "vin" => vin
      })

      response.body
    end

    def process(response)
      doc = Nokogiri::HTML(response)
      table = doc.css("#form table table")
      if table.empty?
        []
      else
        table.css("tr").drop(1).reduce([]) do |memo, row|
          cells = row.css("td")
          memo << {
            oem_number: cells[0].text,
            description: cells[1].text,
            nhtsa_number: cells[2].text,
            status: cells[3].text
          }
          memo
        end
      end
    end

    def format(recall)
      {
        type: nil,
        nhtsa_number: recall[:nhtsa_number],
        oem_number: recall[:oem_number],
        date: nil,
        title: nil,
        description: recall[:description],
        safety_risk: nil,
        remedy: nil,
        status: recall[:status],
        notes: nil
      }
    end
  end
end
