require "json"

module MotoRecall::Client
  class Jaguar < GenericClient
    def self.url(vin)
      "http://www.jaguarusa.com/owners/vin-recall.html?view=vinRecallQuery&vin=#{vin}"
    end

    def process(response)
      parsed_response = JSON.parse(response)
      parsed_response.has_key?("results") ? parsed_response["results"] : []
    end

    def format(recall)
      {
        type: nil,
        nhtsa_number: recall["number"],
        oem_number: recall["manufacturerRecallNumber"],
        date: recall["date"],
        title: nil,
        description: recall["recallDesc"],
        safety_risk: recall["safetyDescription"],
        remedy: recall["repairDesc"],
        status: recall["status"],
        notes: nil
      }
    end
  end
end
