require "json"

module MotoRecall::Client
  class Kia < GenericClient
    def self.url(vin)
      "http://www.kia.com/us/en/data/owners/recalls/search/#{vin}"
    end

    def process(response)
      parsed_response = JSON.parse(response)
      result = parsed_response["result"]
      result.has_key?("recallsResult") ?  result["recallsResult"]["recalls"] : []
    end

    def format(recall)
      {
        type: nil,
        nhtsa_number: recall["nhtsa_recall_number"],
        oem_number: recall["mfr_recall_number"],
        date: recall["recall_date"],
        title: nil,
        description: recall["recall_description"],
        safety_risk: recall["safety_risk_description"],
        remedy: recall["remedy_description"],
        status: recall["mfr_recall_status"],
        notes: recall["mfr_notes"]
      }
    end
  end
end
