module MotoRecall::Client
  class Mazda < GenericClient
    def self.url(vin)
      "https://www.mazdausa.com/handlers/recall.ajax?vin=#{vin}"
    end
    def process(response)
      data = JSON.parse(response)
      data["body"]["nhtsaRecalls"]
    end

    def format(recall)
      {
        type: nil,
        nhtsa_number: recall["nhtsa"],
        oem_number: recall["number"],
        date: recall["date"],
        title: nil,
        description: recall["description"],
        safety_risk: recall["safetyRisk"],
        remedy: recall["remedy"],
        status: recall["status"],
        notes: recall["notes"]
      }
    end
  end
end
