require "json"

module MotoRecall::Client
  class Mitsubishi < GenericClient
    def self.url(vin = nil)
      "https://www.mitsubishicars.com/rs/warranty?vin=#{vin}"
    end

    def process(response)
      parsed_response = JSON.parse(response)
      oe_recalls = parsed_response["openedRecalls"].nil? ? [] : parsed_response["openedRecalls"]
      nhtsa_recalls = parsed_response["nhtsaOpenRecalls"].nil? ? [] : parsed_response["nhtsaOpenRecalls"]
      oe_recalls + nhtsa_recalls
    end

    def format(recall)
      if recall.has_key?("nhtsaRecallNumber")
        {
          type: recall["recallType"],
          nhtsa_number: recall["nhtsaRecallNumber"],
          oem_number: recall["mfrRecallNumber"],
          date: recall["recallDate"],
          title: nil,
          description: recall["recallDescription"],
          safety_risk: recall["safetyRiskDescription"],
          remedy: recall["remedyDescription"],
          status: recall["mfrRecallStatus"],
          notes: nil
        }
      else
        {
          type: nil,
          nhtsa_number: nil,
          oem_number: recall["recallNumber"],
          date: nil,
          title: nil,
          description: recall["recallDescription"],
          safety_risk: nil,
          remedy: nil,
          status: recall["recallStatus"],
          notes: nil
        }
      end
    end
  end
end
