require "json"

module MotoRecall::Client
  class Subaru < GenericClient
    def self.url(vin)
      "http://www.subaru.com/services/vehicles/recalls/?vin=#{vin}"
    end

    def process(data)
      parsed_data = JSON.parse(data)
      parsed_data["recalls"]
    end

    def format(recall)
      {
        type: recall["type"],
        nhtsa_number: recall["nhtsaRecallNumber"],
        oem_number: recall["code"],
        date: recall["fullDate"],
        title: recall["shortDescription"],
        description: recall["description"],
        safety_risk: recall["safefyRiskDescription"],
        remedy: recall["remedyDescription"],
        status: recall["status"],
        notes: nil
      }
    end
  end
end
