require "json"

module MotoRecall::Client
  class Volkswagen < GenericClient
    def self.url(vin)
      "http://www.vw.com/s2f/vwrecall/vin/#{vin}"
    end

    def process(response)
      parsed_response = JSON.parse(response)
      parsed_response.has_key?("recalls") ? parsed_response["recalls"] : []
    end

    def format(recall)
      {
        type: recall["vwgoaActionType"],
        nhtsa_number: recall["nhtsaRecallNumber"],
        oem_number: recall["mfrRecallNumber"],
        date: recall["recallDate"],
        title: recall["vwgoaActionTitle"],
        description: recall["recallDescription"],
        safety_risk: recall["safetyRiskDescription"],
        remedy: recall["remedyDescription"],
        status: recall["mfrRecallStatus"],
        notes: recall["mfrNotes"]
      }
    end
  end
end
