module MotoRecall
  class Recall
    KEYS = %i(
      type
      nhtsa_number
      oem_number
      date
      title
      description
      safety_risk
      remedy
      status
      notes
    )

    attr_reader *KEYS

    def initialize(hash)
      KEYS.each do |key|
        instance_variable_set("@#{key}", hash[key])
      end
    end

    def to_json
      to_h.to_json
    end

    def to_h
      KEYS.reduce({}) { |h, k| h[k] = send(k); h }
    end

    def keys
      KEYS
    end

    def values
      KEYS.map { |k| send(k) }
    end
  end
end
