module MotoRecall
  class RecallSet
    attr_reader :items, :original_response

    def initialize(recalls, opts = {})
      @items = recalls
      @original_response = opts[:original_response]
    end

    def to_json
      @items.map(&:to_h).to_json
    end

    def respond_to?(sym, include_all = false)
      @items.respond_to?(sym) || super
    end

    def method_missing(sym, *args, &block)
      @items.respond_to?(sym) ? @items.send(sym, *args, &block) : super
    end
  end
end
