require "active_support/cache"

require "colorize"
require "moto_recall"
require "moto_recall/sampler/util"
require "moto_recall/sampler/runner"
require "moto_recall/sampler/sample"

module MotoRecall::Sampler
  CACHE = ActiveSupport::Cache.lookup_store(:file_store, "tmp/cache")

  def self.run(queries)
    Runner.new.samples_for_queries(queries).select do |sample|
      !(sample.recalls.nil? || sample.recalls.empty?)
    end
  end

end
