require "gimme_vins"

module MotoRecall::Sampler
  class Runner
    include MotoRecall::Sampler::Util

    def samples_for_queries(queries)
      @samples ||= queries.map do |make, query|
        vins_for_query(query).map do |vin|
          Sample.new(make, vin, query)
        end
      end.flatten
    end

    def vins_for_query(query)
      label = %Q(VINs for "#{query}")
      fetch_with_caching_and_logging(query, label) do
        GimmeVins.for(query)
      end
    end
  end
end
