
module MotoRecall::Sampler
  class Sample
    include MotoRecall::Sampler::Util

    attr_reader :make, :query, :vin, :recalls

    def initialize(make, vin, query)
      @make = make
      @vin = vin
      @query = query
    end

    def recalls
      begin
        label = %Q(Recalls for :#{@make}, "#{@vin}")
        @recalls ||= fetch_with_caching_and_logging(@vin, label) do
          MotoRecall.find(@make, @vin)
        end
      rescue StandardError => e
        log(%Q(Exception #{e} for :#{@make}, "#{@vin}"), {
          color: :red
        })
        log(e.backtrace.join("\n"), {
          color: :red
        })
      end
    end
  end
end
